package classes

object Fabrica {
  def fabricaCliente (leitor : java.util.Scanner) : Cliente = {
    
  	val linha : String = leitor.nextLine();
  	
  	if(linha.isEmpty())
  	{
  		return null;
  	}
  	
  	val linhaSplitada : Array[String] = linha.split(";");
  	val codigo : Int = java.lang.Integer.parseInt(linhaSplitada(0));
  	val nome : String = linhaSplitada(1);
  	val endereco : String = linhaSplitada(2);
  	val telefone : String = linhaSplitada(3);
  	
  	val dateFormat : java.text.DateFormat = new java.text.SimpleDateFormat("dd/MM/yyyy");
  	val dataCadastro : java.util.Date = dateFormat.parse(linhaSplitada(4));
  	
  	var tipo : Char = linhaSplitada(5).charAt(0);
  	
  	val registro : String = linhaSplitada(6);
  	
  	var inscricao : Int = 0;
  	
  	if(registro == 'J')
  	  inscricao = java.lang.Integer.parseInt(linhaSplitada(7));
  	  	
  	return new Cliente(codigo, nome, endereco, telefone, dataCadastro, tipo, registro, inscricao);
  	
  }
  
  def fabricaFornecedor (leitor : java.util.Scanner) : Fornecedor = {
    
  	val linha : String = leitor.nextLine();
  	
  	if(linha.isEmpty())
  	{
  		return null;
  	}
  	
  	val linhaSplitada : Array[String] = linha.split(";");
  	val codigo : Int = java.lang.Integer.parseInt(linhaSplitada(0));
  	val nome : String = linhaSplitada(1);
  	val endereco : String = linhaSplitada(2);
  	val telefone : String = linhaSplitada(3);
  	val cnpj : String = linhaSplitada(4);
  	val pessoaContato : String = linhaSplitada(5);
  	  	
  	return new Fornecedor(codigo, nome, endereco, telefone, cnpj, pessoaContato);
  	
  } 
  
   def fabricaProduto (leitor : java.util.Scanner) : Produto = {
    
  	val linha : String = leitor.nextLine();
  	
  	if(linha.isEmpty())
  	{
  		return null;
  	}
  	
  	val linhaSplitada : Array[String] = linha.split(";");
  	
  	val codigo : Int = java.lang.Integer.parseInt(linhaSplitada(0));
  	val descricao : String = linhaSplitada(1);
  	val estoqueMinimo : Int = java.lang.Integer.parseInt(linhaSplitada(2));
  	val estoqueAtual : Int = java.lang.Integer.parseInt(linhaSplitada(3));
  	linhaSplitada(4) = linhaSplitada(4).replace(",", ".");
  	val valorCusto : Float = java.lang.Float.valueOf(linhaSplitada(4));
  	val percentualLucro : Int = java.lang.Integer.parseInt(linhaSplitada(5));
  
  	return new Produto(codigo, descricao, estoqueMinimo, estoqueAtual, valorCusto, percentualLucro);
  	
  } 
  
   def fabricaCompra(leitor : java.util.Scanner) : Compra = {
    
  	val linha : String = leitor.nextLine();
  	
  	if(linha.isEmpty())
  	{
  		return null;
  	}
  	
  	val linhaSplitada : Array[String] = linha.split(";");
  	
  	val numNotaFiscal : Int = java.lang.Integer.parseInt(linhaSplitada(0));
  	val codigoFornecedor : Int = java.lang.Integer.parseInt(linhaSplitada(1));
  	
  	val dateFormat : java.text.DateFormat = new java.text.SimpleDateFormat("dd/MM/yyyy");
  	val dataCompra : java.util.Date = dateFormat.parse(linhaSplitada(2));
  	
  	val codigoProduto : Int = java.lang.Integer.parseInt(linhaSplitada(3));
  	val quantidade : Int = java.lang.Integer.parseInt(linhaSplitada(4));
  	
  	return new Compra(numNotaFiscal, codigoFornecedor, dataCompra,  codigoProduto, quantidade);
  	
  } 
   
   def fabricaVenda(leitor : java.util.Scanner) : Venda = {
    
  	val linha : String = leitor.nextLine();
  	
  	if(linha.isEmpty())
  	{
  		return null;
  	}
  	
  	val linhaSplitada : Array[String] = linha.split(";");
  	var codigoCliente : Int = 0;
  	
  	if(linhaSplitada(0).isEmpty())
  	  codigoCliente = -1;
  	else
  	  codigoCliente = java.lang.Integer.parseInt(linhaSplitada(0));
  
  	
  	val dateFormat : java.text.DateFormat = new java.text.SimpleDateFormat("dd/MM/yyyy");
  	val dataVenda : java.util.Date = dateFormat.parse(linhaSplitada(1));
  	
  	val codigoProduto : Int = java.lang.Integer.parseInt(linhaSplitada(2));
  	
  	val quantidade : Int = java.lang.Integer.parseInt(linhaSplitada(3));
  	
  	val modo : Char = linhaSplitada(4).charAt(0);
  	
  	return new Venda(codigoCliente, dataVenda, codigoProduto, quantidade, modo);
  	
  } 
  
  
}