package principal

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.text.NumberFormat;
import java.util.Locale;

import classes._;

object Main
{
  def main (args : Array[String])
  {
    var arqClientes : java.io.File = null;
  	var arqFornecedores : java.io.File = null;
  	var arqProdutos : java.io.File = null;
  	var arqCompras : java.io.File = null;
  	var arqVendas : java.io.File = null;
  	
  	/* Leitura dos arquivos de entrada */
  	
  	var i = 0;
  	while(i < args.length)
  	{
  			if(args(i).equals("-c"))
  			{
  				i = i + 1;
  				arqClientes = new java.io.File(args(i));
  		  }
  			else if(args(i).equals("-f"))
  			{
  				i = i + 1;
  				arqFornecedores = new java.io.File(args(i));
  			}
  			else if(args(i).equals("-p"))
  			{
  				i = i + 1;
  				arqProdutos = new java.io.File(args(i));
  			}
  			else if(args(i).equals("-a"))
  			{
  				i = i + 1;
  				arqCompras = new java.io.File(args(i));
  			}
  			else if(args(i).equals("-v"))
  			{
  				i = i + 1;
  				arqVendas = new java.io.File(args(i));
  			}
  			i = i + 1;
  	}
  
    if(arqClientes != null && arqFornecedores != null && arqProdutos != null && arqCompras != null && arqVendas != null )
    {
      var sc : java.util.Scanner = null;
      
      var listaClientes : List[Cliente] =  List();
      var listaCompras : List[Compra] =  List();
      var listaFornecedores : List[Fornecedor] =  List();
      var listaProdutos : List[Produto] =  List();
      var listaVendas : List[Venda] =  List();
      
      sc = new java.util.Scanner(arqClientes);
		  sc.nextLine();
		  
		  while(sc.hasNextLine())
		  {
			  val c : Cliente = Fabrica.fabricaCliente(sc);
  			if(c != null)
  			{
  			  listaClientes = listaClientes :+ c
  			}
		  }
		  
		  sc = new java.util.Scanner(arqFornecedores);
		  sc.nextLine();
		  
		  while(sc.hasNextLine())
		  {
			  val c : Fornecedor = Fabrica.fabricaFornecedor(sc);
  			if(c != null)
  			{
  			  listaFornecedores =  listaFornecedores :+ c
  			}
		  }
		  
		  sc = new java.util.Scanner(arqProdutos);
		  sc.nextLine();
		  
		  while(sc.hasNextLine())
		  {
			  val c : Produto = Fabrica.fabricaProduto(sc);
  			if(c != null)
  			{
  			  listaProdutos =  listaProdutos :+ c
  			}
		  }
		  
		  sc = new java.util.Scanner(arqCompras);
		  sc.nextLine();
		  
		  while(sc.hasNextLine())
		  {
			  val c : Compra = Fabrica.fabricaCompra(sc);
  			if(c != null)
  			{
  			  listaCompras =  listaCompras :+ c
  			}
		  }
		  
		  sc = new java.util.Scanner(arqVendas);
		  sc.nextLine();
		  
		  while(sc.hasNextLine())
		  {
			  val c : Venda = Fabrica.fabricaVenda(sc);
  			if(c != null)
  			{
  			  listaVendas =  listaVendas :+ c
  			}
		  }
		  
		  /*RELATORIO 1*/
		  
		  var listaLinhas1 : List[String] =  List();
		  
		  listaFornecedores = listaFornecedores.sortWith(_.nome < _.nome)

		  listaLinhas1 = listaLinhas1 :+ "Fornecedor;CNPJ;Pessoa de contato ;Telefone;Total a pagar";
		  
		  listaFornecedores.foreach 
		  {
		    fornecedor => val codigoFornecedor = fornecedor.codigo
		    val compras = listaCompras.filter { compra => compra.codigoFornecedor == codigoFornecedor}
		    var aPagar : Float = 0;
		    compras.foreach
		    {
		      compra => 
		         aPagar = aPagar + compra.quantidade.toFloat*(listaProdutos.find{produto => produto.codigo == compra.codigoProduto}).get.valorCusto
		    }
		    val nf : java.text.NumberFormat = NumberFormat.getCurrencyInstance(new java.util.Locale("pt", "br"));
		    val texto = fornecedor.nome + ";" + fornecedor.cnpj + ";" + fornecedor.pessoaContato + ";" + fornecedor.telefone + ";" + nf.format(aPagar)
		    listaLinhas1 = listaLinhas1 :+ texto
		  }
		  
		  Relatorios.gerarRelatorio1(listaLinhas1)
		  
		  /*RELATORIO 2*/
		  
		  var listaLinhas2 : List[String] =  List();
		  
		  listaLinhas2 = listaLinhas2 :+ "Cliente;Tipo;CPF/CNPJ;Telefone;Data de cadastro;Total a pagar";
		  
		  listaClientes = listaClientes.sortWith(_.nome < _.nome)
		  
		  listaClientes.foreach
		  {
		    cliente => val numCliente = cliente.codigo
		    var vendas = listaVendas.filter{ y => y.codigoCliente == numCliente}
		    var aReceber : Float = 0;
		    vendas.foreach
		    {
		   	  venda => 
		   	    val produto = listaProdutos.find {produto => produto.codigo == venda.codigoProduto}.get
		   	    aReceber = aReceber + venda.quantidade.toFloat*produto.valorCusto*(100 + produto.percentualLucro)/100;
		    }
		    val df : java.text.DateFormat = new java.text.SimpleDateFormat("dd/MM/yyyy");
		    val nf : java.text.NumberFormat = NumberFormat.getCurrencyInstance(new java.util.Locale("pt", "br"));
		    val texto = cliente.nome + ";" + cliente.tipo + ";" + cliente.registro + ";" + cliente.telefone + ";" + df.format(cliente.data) + ";" + nf.format(aReceber.toDouble)
		    listaLinhas2 = listaLinhas2 :+ texto
		  }
		  
		  Relatorios.gerarRelatorio2(listaLinhas2)
    }
    else
    {
      println("Aconteceu um erro com os arquivos de entrada, por favor reveja se você digitou tudo corretamente");
    }
  
  }
  
}